<?php


	function quoted($item) {
		return "'" . $item . '\'';
	}


	function getDBSequence() {
		$conn = getConnection();
		if ($conn->connect_error)  {
			return 0;
		}
		$sql = 'UPDATE sequence SET id=LAST_INSERT_ID(id+1);';
		$result = $conn->query($sql);
		if ( $result ){
			$sql ='SELECT * FROM `sequence` '; // SELECT LAST_INSERT_ID()';
			$result = $conn->query($sql);
			if ( $result ){
				while ( $row = $result->fetch_array() ) {
					$sequence = intval($row[0]) ;
				} // while
			}  // if
		}
		else {
			// die('SQL-Anweisung gescheitert');
			$sequence = 0;
		}
		return $sequence;
	}

	function getConnection() {
		$servername='localhost';
		$username='root';
		$passwd='';
		$database='amacon';
		$conn = new mysqli($servername, $username, $passwd, $database);
		if ($conn->connect_error)  {
			die('Connection failed: ' . $conn->connect_error);
		}
		return $conn;
	}

	function loadCustomersFromDB() {
		$result = new Result();
		$conn = getConnection();
		if ($conn->connect_error)  {
			$result->isError=true;
			$result->errortext = "Keine Verbindung zur Datenbank" . '<br />';
			return $result;
		}
		$sql = 'select pindex,cno, lastname, firstname, street, birthday from customer';
		$resultsql = $conn->query($sql);
		// wenn result=true, dann gibt es Zeilen
		if ($resultsql) {
			while( $row=$resultsql->fetch_array()) {
				$customer = new Customer();
				$customer->pindex = intval( $row['pindex'] );
				$customer->cno = intval( $row['cno'] );
				$customer->lastname =  $row['lastname'];
				$customer->firstname = $row['firstname'];
				$customer->street = $row['street'];
				$customer->birthday = $row['birthday'];
				$result->arr[]=$customer; // element ans Ende hinzufügen
			}
		}
		else {
			$result->errortext="Fehlerhafte SQL-Anweisung<br />SQL: $sql<br />";
			$result->isError=true;
		}
		return $result;
	}  // loadCustomersFromDB

	function loadCustomerFromDB($pindex) {
		$result = new Result();
		$conn = getConnection();
		if ($conn->connect_error)  {
			$result->isError=true;
			$result->errortext = "Keine Verbindung zur Datenbank" . '<br />';
			return $result;
		}
		$sql = 'select pindex,cno, lastname, firstname, street, birthday ' .
		' from customer  where pindex=' . $pindex;

		$resultsql = $conn->query($sql);
		// wenn result=true, dann gibt es Zeilen
		if ($resultsql) {
			while( $row=$resultsql->fetch_array()) {
				$customer = new Customer();
				$customer->pindex = intval( $row['pindex'] );
				$customer->cno = intval( $row['cno'] );
				$customer->lastname =  $row['lastname'];
				$customer->firstname = $row['firstname'];
				$customer->street = $row['street'];
				$customer->birthday = $row['birthday'];
				$result->arr[]=$customer; // element ans Ende hinzufügen
				break;
			}
		}
		else {
			$result->errortext="Fehlerhafte SQL-Anweisung<br />SQL: $sql<br />";
			$result->isError=true;
		}
		return $result;
	}  // loadCustomerFromDB




	function  updateCustomerDB($customer) {
		$result = new Result();
		$sql = 'UPDATE customer ' .
		'SET  ' .
		' `CNO`=' . $customer->cno . ', ' .
		' `LASTNAME`=' . quoted($customer->lastname) . ', ' .
		' `FIRSTNAME`=' . quoted($customer->firstname) . ', ' .
		' `STREET`=' . quoted($customer->street) . ', ' .
		' `BIRTHDAY`=' . quoted($customer->birthday) .
		'  WHERE `PINDEX`=' . $customer->pindex;

		$conn = getConnection();
		if ($conn->connect_error)  {
			$result->isError=true;
			$result->errortext = "Keine Verbindung zur Datenbank" . '<br />';
			// return false;
		}
		$resultsql = $conn->query($sql);
		if ($resultsql) {
			// hier war alles in Ordnung!
		}
		else {
			$result->isError=true;
			$result->errortext = $sql . '<br />' . $conn->error . '<br />';
		}

		return $result;
	}  // updateCustomerDB


	function  deleteCustomerDB($pindex) {
		$result = new Result();
		$sql = 'DELETE FROM  customer  WHERE `PINDEX`=' . $pindex;

		$conn = getConnection();
		if ($conn->connect_error)  {
			$result->isError=true;
			$result->errortext = "Keine Verbindung zur Datenbank" . '<br />';
		}

		$resultsql = $conn->query($sql);
		if ($resultsql) {
			// hier war alles in Ordnung!
		}
		else {
			$result->isError=true;
			$result->errortext = $sql . '<br />' . $conn->error . '<br />';
		}

		return $result;
	}  // deleteCustomerDB



	function insertCustomerDB($customer) {
		$result = new Result();
		$conn = getConnection();
		if ($conn->connect_error)  {
			$result->isError=true;
			$result->errortext = "Keine Verbindung zur Datenbank" . '<br />';
		}

		$sql = 'INSERT INTO customer(PINDEX, CNO, LASTNAME, FIRSTNAME, STREET,  BIRTHDAY)' .
		' VALUES(  ' .
		' ' . $customer->pindex . ', ' .
		' ' . $customer->cno . ', ' .
		' ' . quoted($customer->lastname) . ', ' .
		' ' . quoted($customer->firstname) . ', ' .
		' ' . quoted($customer->street) . ', ' .
		' ' . quoted($customer->birthday) .
		' )';

		if ($conn->query($sql))  {
			// alles okay
		}
		else {
			$result->isError=true;
			$result->errortext = $sql . '<br />' . $conn->error . '<br />';
		}
		return $result;
	} // insertCustomerDB


?>

