<?php




	class UIPattern{
		public $uikey='';  // lastname oder birthday
		public $uityp='';   // date oder number text
		public $caption='';
		public $minval=0;
		public $maxval=0;
		public $uipattern='';
	}


	function getCustomerPatternFromDB() {
		$result = new Result();
		//  $isError,  $error,  $uipatternliste
		$conn = getConnection();
		if ($conn->connect_error)  {
			$result->isError=true;
			$result->errortext = $conn->connect_error;
			return $result;
		}

		$sql = 'SELECT uikey, uityp, caption, minval, maxval, pattern from uipattern';
		$resultSQL = $conn->query($sql);

		//  __construct($uikey, $uityp, $caption, $minval, $maxval,  $pattern) {

			if ($resultSQL) {
				while($row=$resultSQL->fetch_array()) {
					$uipattern = new UIPattern();
					$uipattern->uikey=$row['uikey'];
					$uipattern->uityp=$row['uityp'];
					$uipattern->caption=$row['caption'];
					$uipattern->minval=intval($row['minval']);
					$uipattern->maxval=intval($row['maxval']);
					$uipattern->uipattern=$row['pattern'];
					$result->uipatternliste[] = $uipattern;
				}  // while
			}  // else
			else {
				$result->isError=true;
				$result->error = 'Fehlerhafte SQL-Anweisung<br />' . $conn->error . '<br />' . $sql;
			}

			$conn->close();

			return $result;
		}


		function quoted($item) {
			return "'" . $item . '\'';
		}


		function getDBSequence() {
			$conn = getConnection();
			if ($conn->connect_error)  {
				return 0;
			}
			$sql = 'UPDATE sequence SET id=LAST_INSERT_ID(id+1);';
			$result = $conn->query($sql);
			if ( $result ){
				$sql ='SELECT * FROM `sequence` '; // SELECT LAST_INSERT_ID()';
				$result = $conn->query($sql);
				if ( $result ){
					while ( $row = $result->fetch_array() ) {
						$sequence = intval($row[0]) ;
					} // while
				}  // if
			}
			else {
				// die('SQL-Anweisung gescheitert');
				$sequence = 0;
			}
			return $sequence;
		}

		function getConnection() {
			$servername='localhost';
			$username='root';
			$passwd='';
			$database='amacon';
			$conn = new mysqli($servername, $username, $passwd, $database);
			if ($conn->connect_error)  {
				die('Connection failed: ' . $conn->connect_error);
			}
			return $conn;
		}

		function loadCustomersFromDB() {
			$result = new Result();
			$conn = getConnection();
			if ($conn->connect_error)  {
				$result->isError=true;
				$result->errortext = "Keine Verbindung zur Datenbank" . '<br />';
				return $result;
			}
			$sql = 'select pindex,cno, lastname, firstname, street, birthday from customer';
			$resultsql = $conn->query($sql);
			// wenn result=true, dann gibt es Zeilen
			if ($resultsql) {
				while( $row=$resultsql->fetch_array()) {
					$customer = new Customer();
					$customer->pindex = intval( $row['pindex'] );
					$customer->cno = intval( $row['cno'] );
					$customer->lastname =  $row['lastname'];
					$customer->firstname = $row['firstname'];
					$customer->street = $row['street'];
					$customer->birthday = $row['birthday'];
					$result->arr[]=$customer; // element ans Ende hinzufügen
				}
			}
			else {
				$result->errortext="Fehlerhafte SQL-Anweisung<br />SQL: $sql<br />";
				$result->isError=true;
			}
			return $result;
		}  // loadCustomersFromDB

		function loadCustomerFromDB($pindex) {
			$result = new Result();
			$conn = getConnection();
			if ($conn->connect_error)  {
				$result->isError=true;
				$result->errortext = "Keine Verbindung zur Datenbank" . '<br />';
				return $result;
			}
			$sql = 'select pindex,cno, lastname, firstname, street, birthday ' .
			' from customer  where pindex=' . $pindex;

			$resultsql = $conn->query($sql);
			// wenn result=true, dann gibt es Zeilen
			if ($resultsql) {
				while( $row=$resultsql->fetch_array()) {
					$customer = new Customer();
					$customer->pindex = intval( $row['pindex'] );
					$customer->cno = intval( $row['cno'] );
					$customer->lastname =  $row['lastname'];
					$customer->firstname = $row['firstname'];
					$customer->street = $row['street'];
					$customer->birthday = $row['birthday'];
					$result->arr[]=$customer; // element ans Ende hinzufügen
					break;
				}
			}
			else {
				$result->errortext="Fehlerhafte SQL-Anweisung<br />SQL: $sql<br />";
				$result->isError=true;
			}
			return $result;
		}  // loadCustomerFromDB


		function loadCustomerAndPatternFromDB($pindex) {
			$result = new Result();
			$conn = getConnection();
			if ($conn->connect_error)  {
				$result->isError=true;
				$result->errortext = "Keine Verbindung zur Datenbank" . '<br />';
				return $result;
			}
			$sql = 'select pindex,cno, lastname, firstname, street, birthday ' .
			' from customer  where pindex=' . $pindex;

			$resultsql = $conn->query($sql);
			// wenn result=true, dann gibt es Zeilen
			if ($resultsql) {
				$gefunden=false;
				while( $row=$resultsql->fetch_array()) {
					$customer = new Customer();
					$customer->pindex = intval( $row['pindex'] );
					$customer->cno = intval( $row['cno'] );
					$customer->lastname =  $row['lastname'];
					$customer->firstname = $row['firstname'];
					$customer->street = $row['street'];
					$customer->birthday = $row['birthday'];
					$result->arr[]=$customer; // element ans Ende hinzufügen
					$gefunden=true;
					break;
				}
				if ($gefunden) {
					$resultPattern = getCustomerPatternFromDB();
					if ($resultPattern->isError) {
						$result->isError=true;
						$result->errortext = $resultPattern->errortext;
					}
					else {
						$result->uipatternliste = $resultPattern->uipatternliste;
					}

				}
				else {
					$result->errortext="Der Customer war nicht da";
					$result->isError=true;
				}
			}
			else {
				$result->errortext="Fehlerhafte SQL-Anweisung<br />SQL: $sql<br />";
				$result->isError=true;
			}
			return $result;
		}  // loadCustomerFromDB


		function  updateCustomerDB($customer) {
			$result = new Result();
			$sql = 'UPDATE customer ' .
			'SET  ' .
			' `CNO`=' . $customer->cno . ', ' .
			' `LASTNAME`=' . quoted($customer->lastname) . ', ' .
			' `FIRSTNAME`=' . quoted($customer->firstname) . ', ' .
			' `STREET`=' . quoted($customer->street) . ', ' .
			' `BIRTHDAY`=' . quoted($customer->birthday) .
			'  WHERE `PINDEX`=' . $customer->pindex;

			$conn = getConnection();
			if ($conn->connect_error)  {
				$result->isError=true;
				$result->errortext = "Keine Verbindung zur Datenbank" . '<br />';
				// return false;
			}
			$resultsql = $conn->query($sql);
			if ($resultsql) {
				// hier war alles in Ordnung!
			}
			else {
				$result->isError=true;
				$result->errortext = $sql . '<br />' . $conn->error . '<br />';
			}

			return $result;
		}  // updateCustomerDB


		function  deleteCustomerDB($pindex) {
			$result = new Result();
			$sql = 'DELETE FROM  customer  WHERE `PINDEX`=' . $pindex;

			$conn = getConnection();
			if ($conn->connect_error)  {
				$result->isError=true;
				$result->errortext = "Keine Verbindung zur Datenbank" . '<br />';
			}

			$resultsql = $conn->query($sql);
			if ($resultsql) {
				// hier war alles in Ordnung!
			}
			else {
				$result->isError=true;
				$result->errortext = $sql . '<br />' . $conn->error . '<br />';
			}

			return $result;
		}  // deleteCustomerDB



		function insertCustomerDB($customer) {
			$result = new Result();
			$conn = getConnection();
			if ($conn->connect_error)  {
				$result->isError=true;
				$result->errortext = "Keine Verbindung zur Datenbank" . '<br />';
			}

			$sql = 'INSERT INTO customer(PINDEX, CNO, LASTNAME, FIRSTNAME, STREET,  BIRTHDAY)' .
			' VALUES(  ' .
			' ' . $customer->pindex . ', ' .
			' ' . $customer->cno . ', ' .
			' ' . quoted($customer->lastname) . ', ' .
			' ' . quoted($customer->firstname) . ', ' .
			' ' . quoted($customer->street) . ', ' .
			' ' . quoted($customer->birthday) .
			' )';

			if ($conn->query($sql))  {
				// alles okay
			}
			else {
				$result->isError=true;
				$result->errortext = $sql . '<br />' . $conn->error . '<br />';
			}
			return $result;
		} // insertCustomerDB


	?>